Code

Turn builtin_exec_path into a function.
[git.git] / t / t7004-tag.sh
index a845930404ac51f15de891ce58dada9e009f4aee..241c70dc66f71d9f53ddc6637e2f813020e740d6 100755 (executable)
@@ -5,7 +5,7 @@
 
 test_description='git-tag
 
-Basic tests for operations with tags.'
+Tests for operations with tags.'
 
 . ./test-lib.sh
 
@@ -16,14 +16,18 @@ tag_exists () {
 }
 
 # todo: git tag -l now returns always zero, when fixed, change this test
-test_expect_success 'listing all tags in an empty tree should succeed' \
-       'git tag -l'
+test_expect_success 'listing all tags in an empty tree should succeed' '
+       git tag -l &&
+       git tag
+'
 
-test_expect_success 'listing all tags in an empty tree should output nothing' \
-       'test `git-tag -l | wc -l` -eq 0'
+test_expect_success 'listing all tags in an empty tree should output nothing' '
+       test `git-tag -l | wc -l` -eq 0 &&
+       test `git-tag | wc -l` -eq 0
+'
 
-test_expect_failure 'looking for a tag in an empty tree should fail' \
-       'tag_exists mytag'
+test_expect_success 'looking for a tag in an empty tree should fail' \
+       '! (tag_exists mytag)'
 
 test_expect_success 'creating a tag in an empty tree should fail' '
        ! git-tag mynotag &&
@@ -49,11 +53,15 @@ test_expect_success 'creating a tag using default HEAD should succeed' '
        git tag mytag
 '
 
-test_expect_success 'listing all tags if one exists should succeed' \
-       'git-tag -l'
+test_expect_success 'listing all tags if one exists should succeed' '
+       git-tag -l &&
+       git-tag
+'
 
-test_expect_success 'listing all tags if one exists should output that tag' \
-       'test `git-tag -l` = mytag'
+test_expect_success 'listing all tags if one exists should output that tag' '
+       test `git-tag -l` = mytag &&
+       test `git-tag` = mytag
+'
 
 # pattern matching:
 
@@ -75,9 +83,9 @@ test_expect_success \
 
 # special cases for creating tags:
 
-test_expect_failure \
+test_expect_success \
        'trying to create a tag with the name of one existing should fail' \
-       'git tag mytag'
+       'git tag mytag'
 
 test_expect_success \
        'trying to create a tag with a non-valid name should fail' '
@@ -108,9 +116,9 @@ mytag
 EOF
 test_expect_success \
        'trying to delete tags without params should succeed and do nothing' '
-       git tag -l > actual && git diff expect actual &&
+       git tag -l > actual && test_cmp expect actual &&
        git-tag -d &&
-       git tag -l > actual && git diff expect actual
+       git tag -l > actual && test_cmp expect actual
 '
 
 test_expect_success \
@@ -138,8 +146,8 @@ test_expect_success \
        ! tag_exists myhead
 '
 
-test_expect_failure 'trying to delete an already deleted tag should fail' \
-       'git-tag -d mytag'
+test_expect_success 'trying to delete an already deleted tag should fail' \
+       'git-tag -d mytag'
 
 # listing various tags with pattern matching:
 
@@ -164,8 +172,10 @@ test_expect_success 'listing all tags should print them ordered' '
        git tag a1 &&
        git tag v1.0 &&
        git tag t210 &&
-       git tag -l > actual
-       git diff expect actual
+       git tag -l > actual &&
+       test_cmp expect actual &&
+       git tag > actual &&
+       test_cmp expect actual
 '
 
 cat >expect <<EOF
@@ -175,19 +185,18 @@ cba
 EOF
 test_expect_success \
        'listing tags with substring as pattern must print those matching' '
-       git-tag -l a > actual &&
-       git diff expect actual
+       git-tag -l "*a*" > actual &&
+       test_cmp expect actual
 '
 
 cat >expect <<EOF
 v0.2.1
 v1.0.1
-v1.1.3
 EOF
 test_expect_success \
-       'listing tags with substring as pattern must print those matching' '
-       git-tag -l .1 > actual &&
-       git diff expect actual
+       'listing tags with a suffix as pattern must print those matching' '
+       git-tag -l "*.1" > actual &&
+       test_cmp expect actual
 '
 
 cat >expect <<EOF
@@ -195,45 +204,44 @@ t210
 t211
 EOF
 test_expect_success \
-       'listing tags with substring as pattern must print those matching' '
-       git-tag -l t21 > actual &&
-       git diff expect actual
+       'listing tags with a prefix as pattern must print those matching' '
+       git-tag -l "t21*" > actual &&
+       test_cmp expect actual
 '
 
 cat >expect <<EOF
 a1
-aa1
 EOF
 test_expect_success \
-       'listing tags using a name as pattern must print those matching' '
+       'listing tags using a name as pattern must print that one matching' '
        git-tag -l a1 > actual &&
-       git diff expect actual
+       test_cmp expect actual
 '
 
 cat >expect <<EOF
 v1.0
-v1.0.1
 EOF
 test_expect_success \
-       'listing tags using a name as pattern must print those matching' '
+       'listing tags using a name as pattern must print that one matching' '
        git-tag -l v1.0 > actual &&
-       git diff expect actual
+       test_cmp expect actual
 '
 
 cat >expect <<EOF
+v1.0.1
 v1.1.3
 EOF
 test_expect_success \
        'listing tags with ? in the pattern should print those matching' '
-       git-tag -l "1.1?" > actual &&
-       git diff expect actual
+       git-tag -l "v1.?.?" > actual &&
+       test_cmp expect actual
 '
 
 >expect
 test_expect_success \
        'listing tags using v.* should print nothing because none have v.' '
        git-tag -l "v.*" > actual &&
-       git diff expect actual
+       test_cmp expect actual
 '
 
 cat >expect <<EOF
@@ -245,7 +253,7 @@ EOF
 test_expect_success \
        'listing tags using v* should print only those having v' '
        git-tag -l "v*" > actual &&
-       git diff expect actual
+       test_cmp expect actual
 '
 
 # creating and verifying lightweight tags:
@@ -257,12 +265,16 @@ test_expect_success \
        test $(git rev-parse non-annotated-tag) = $(git rev-parse HEAD)
 '
 
-test_expect_failure 'trying to verify an unknown tag should fail' \
-       'git-tag -v unknown-tag'
+test_expect_success 'trying to verify an unknown tag should fail' \
+       'git-tag -v unknown-tag'
 
-test_expect_failure \
+test_expect_success \
        'trying to verify a non-annotated and non-signed tag should fail' \
-       'git-tag -v non-annotated-tag'
+       '! git-tag -v non-annotated-tag'
+
+test_expect_success \
+       'trying to verify many non-annotated or unknown tags, should fail' \
+       '! git-tag -v unknown-tag1 non-annotated-tag unknown-tag2'
 
 # creating annotated tags:
 
@@ -290,7 +302,7 @@ test_expect_success \
        'creating an annotated tag with -m message should succeed' '
        git-tag -m "A message" annotated-tag &&
        get_tag_msg annotated-tag >actual &&
-       git diff expect actual
+       test_cmp expect actual
 '
 
 cat >msgfile <<EOF
@@ -303,7 +315,40 @@ test_expect_success \
        'creating an annotated tag with -F messagefile should succeed' '
        git-tag -F msgfile file-annotated-tag &&
        get_tag_msg file-annotated-tag >actual &&
-       git diff expect actual
+       test_cmp expect actual
+'
+
+cat >inputmsg <<EOF
+A message from the
+standard input
+EOF
+get_tag_header stdin-annotated-tag $commit commit $time >expect
+cat inputmsg >>expect
+test_expect_success 'creating an annotated tag with -F - should succeed' '
+       git-tag -F - stdin-annotated-tag <inputmsg &&
+       get_tag_msg stdin-annotated-tag >actual &&
+       test_cmp expect actual
+'
+
+test_expect_success \
+       'trying to create a tag with a non-existing -F file should fail' '
+       ! test -f nonexistingfile &&
+       ! tag_exists notag &&
+       ! git-tag -F nonexistingfile notag &&
+       ! tag_exists notag
+'
+
+test_expect_success \
+       'trying to create tags giving both -m or -F options should fail' '
+       echo "message file 1" >msgfile1 &&
+       echo "message file 2" >msgfile2 &&
+       ! tag_exists msgtag &&
+       ! git-tag -m "message 1" -F msgfile1 msgtag &&
+       ! tag_exists msgtag &&
+       ! git-tag -F msgfile1 -m "message 1" msgtag &&
+       ! tag_exists msgtag &&
+       ! git-tag -m "message 1" -F msgfile1 -m "message 2" msgtag &&
+       ! tag_exists msgtag
 '
 
 # blank and empty messages:
@@ -313,7 +358,7 @@ test_expect_success \
        'creating a tag with an empty -m message should succeed' '
        git-tag -m "" empty-annotated-tag &&
        get_tag_msg empty-annotated-tag >actual &&
-       git diff expect actual
+       test_cmp expect actual
 '
 
 >emptyfile
@@ -322,7 +367,7 @@ test_expect_success \
        'creating a tag with an empty -F messagefile should succeed' '
        git-tag -F emptyfile emptyfile-annotated-tag &&
        get_tag_msg emptyfile-annotated-tag >actual &&
-       git diff expect actual
+       test_cmp expect actual
 '
 
 printf '\n\n  \n\t\nLeading blank lines\n' >blanksfile
@@ -343,7 +388,7 @@ test_expect_success \
        'extra blanks in the message for an annotated tag should be removed' '
        git-tag -F blanksfile blanks-annotated-tag &&
        get_tag_msg blanks-annotated-tag >actual &&
-       git diff expect actual
+       test_cmp expect actual
 '
 
 get_tag_header blank-annotated-tag $commit commit $time >expect
@@ -351,7 +396,7 @@ test_expect_success \
        'creating a tag with blank -m message with spaces should succeed' '
        git-tag -m "     " blank-annotated-tag &&
        get_tag_msg blank-annotated-tag >actual &&
-       git diff expect actual
+       test_cmp expect actual
 '
 
 echo '     ' >blankfile
@@ -362,7 +407,7 @@ test_expect_success \
        'creating a tag with blank -F messagefile with spaces should succeed' '
        git-tag -F blankfile blankfile-annotated-tag &&
        get_tag_msg blankfile-annotated-tag >actual &&
-       git diff expect actual
+       test_cmp expect actual
 '
 
 printf '      ' >blanknonlfile
@@ -371,7 +416,7 @@ test_expect_success \
        'creating a tag with -F file of spaces and no newline should succeed' '
        git-tag -F blanknonlfile blanknonlfile-annotated-tag &&
        get_tag_msg blanknonlfile-annotated-tag >actual &&
-       git diff expect actual
+       test_cmp expect actual
 '
 
 # messages with commented lines:
@@ -406,7 +451,7 @@ test_expect_success \
        'creating a tag using a -F messagefile with #comments should succeed' '
        git-tag -F commentsfile comments-annotated-tag &&
        get_tag_msg comments-annotated-tag >actual &&
-       git diff expect actual
+       test_cmp expect actual
 '
 
 get_tag_header comment-annotated-tag $commit commit $time >expect
@@ -414,7 +459,7 @@ test_expect_success \
        'creating a tag with a #comment in the -m message should succeed' '
        git-tag -m "#comment" comment-annotated-tag &&
        get_tag_msg comment-annotated-tag >actual &&
-       git diff expect actual
+       test_cmp expect actual
 '
 
 echo '#comment' >commentfile
@@ -425,7 +470,7 @@ test_expect_success \
        'creating a tag with #comments in the -F messagefile should succeed' '
        git-tag -F commentfile commentfile-annotated-tag &&
        get_tag_msg commentfile-annotated-tag >actual &&
-       git diff expect actual
+       test_cmp expect actual
 '
 
 printf '#comment' >commentnonlfile
@@ -434,9 +479,113 @@ test_expect_success \
        'creating a tag with a file of #comment and no newline should succeed' '
        git-tag -F commentnonlfile commentnonlfile-annotated-tag &&
        get_tag_msg commentnonlfile-annotated-tag >actual &&
-       git diff expect actual
+       test_cmp expect actual
+'
+
+# listing messages for annotated non-signed tags:
+
+test_expect_success \
+       'listing the one-line message of a non-signed tag should succeed' '
+       git-tag -m "A msg" tag-one-line &&
+
+       echo "tag-one-line" >expect &&
+       git-tag -l | grep "^tag-one-line" >actual &&
+       test_cmp expect actual &&
+       git-tag -n0 -l | grep "^tag-one-line" >actual &&
+       test_cmp expect actual &&
+       git-tag -n0 -l tag-one-line >actual &&
+       test_cmp expect actual &&
+
+       echo "tag-one-line    A msg" >expect &&
+       git-tag -n1 -l | grep "^tag-one-line" >actual &&
+       test_cmp expect actual &&
+       git-tag -n -l | grep "^tag-one-line" >actual &&
+       test_cmp expect actual &&
+       git-tag -n1 -l tag-one-line >actual &&
+       test_cmp expect actual &&
+       git-tag -n2 -l tag-one-line >actual &&
+       test_cmp expect actual &&
+       git-tag -n999 -l tag-one-line >actual &&
+       test_cmp expect actual
 '
 
+test_expect_success \
+       'listing the zero-lines message of a non-signed tag should succeed' '
+       git-tag -m "" tag-zero-lines &&
+
+       echo "tag-zero-lines" >expect &&
+       git-tag -l | grep "^tag-zero-lines" >actual &&
+       test_cmp expect actual &&
+       git-tag -n0 -l | grep "^tag-zero-lines" >actual &&
+       test_cmp expect actual &&
+       git-tag -n0 -l tag-zero-lines >actual &&
+       test_cmp expect actual &&
+
+       echo "tag-zero-lines  " >expect &&
+       git-tag -n1 -l | grep "^tag-zero-lines" >actual &&
+       test_cmp expect actual &&
+       git-tag -n -l | grep "^tag-zero-lines" >actual &&
+       test_cmp expect actual &&
+       git-tag -n1 -l tag-zero-lines >actual &&
+       test_cmp expect actual &&
+       git-tag -n2 -l tag-zero-lines >actual &&
+       test_cmp expect actual &&
+       git-tag -n999 -l tag-zero-lines >actual &&
+       test_cmp expect actual
+'
+
+echo 'tag line one' >annotagmsg
+echo 'tag line two' >>annotagmsg
+echo 'tag line three' >>annotagmsg
+test_expect_success \
+       'listing many message lines of a non-signed tag should succeed' '
+       git-tag -F annotagmsg tag-lines &&
+
+       echo "tag-lines" >expect &&
+       git-tag -l | grep "^tag-lines" >actual &&
+       test_cmp expect actual &&
+       git-tag -n0 -l | grep "^tag-lines" >actual &&
+       test_cmp expect actual &&
+       git-tag -n0 -l tag-lines >actual &&
+       test_cmp expect actual &&
+
+       echo "tag-lines       tag line one" >expect &&
+       git-tag -n1 -l | grep "^tag-lines" >actual &&
+       test_cmp expect actual &&
+       git-tag -n -l | grep "^tag-lines" >actual &&
+       test_cmp expect actual &&
+       git-tag -n1 -l tag-lines >actual &&
+       test_cmp expect actual &&
+
+       echo "    tag line two" >>expect &&
+       git-tag -n2 -l | grep "^ *tag.line" >actual &&
+       test_cmp expect actual &&
+       git-tag -n2 -l tag-lines >actual &&
+       test_cmp expect actual &&
+
+       echo "    tag line three" >>expect &&
+       git-tag -n3 -l | grep "^ *tag.line" >actual &&
+       test_cmp expect actual &&
+       git-tag -n3 -l tag-lines >actual &&
+       test_cmp expect actual &&
+       git-tag -n4 -l | grep "^ *tag.line" >actual &&
+       test_cmp expect actual &&
+       git-tag -n4 -l tag-lines >actual &&
+       test_cmp expect actual &&
+       git-tag -n99 -l | grep "^ *tag.line" >actual &&
+       test_cmp expect actual &&
+       git-tag -n99 -l tag-lines >actual &&
+       test_cmp expect actual
+'
+
+# subsequent tests require gpg; check if it is available
+gpg --version >/dev/null
+if [ $? -eq 127 ]; then
+       echo "gpg not found - skipping tag signing and verification tests"
+       test_done
+       exit
+fi
+
 # trying to verify annotated non-signed tags:
 
 test_expect_success \
@@ -451,14 +600,24 @@ test_expect_success \
        ! git-tag -v file-annotated-tag
 '
 
+test_expect_success \
+       'trying to verify two annotated non-signed tags should fail' '
+       tag_exists annotated-tag file-annotated-tag &&
+       ! git-tag -v annotated-tag file-annotated-tag
+'
+
 # creating and verifying signed tags:
 
-gpg --version >/dev/null
-if [ $? -eq 127 ]; then
-       echo "Skipping signed tags tests, because gpg was not found"
+# As said here: http://www.gnupg.org/documentation/faqs.html#q6.19
+# the gpg version 1.0.6 didn't parse trust packets correctly, so for
+# that version, creation of signed tags using the generated key fails.
+case "$(gpg --version)" in
+'gpg (GnuPG) 1.0.6'*)
+       echo "Skipping signed tag tests, because a bug in 1.0.6 version"
        test_done
        exit
-fi
+       ;;
+esac
 
 # key generation info: gpg --homedir t/t7004 --gen-key
 # Type DSA and Elgamal, size 2048 bits, no expiration date.
@@ -467,7 +626,8 @@ fi
 
 cp -R ../t7004 ./gpghome
 chmod 0700 gpghome
-export GNUPGHOME="$(pwd)/gpghome"
+GNUPGHOME="$(pwd)/gpghome"
+export GNUPGHOME
 
 get_tag_header signed-tag $commit commit $time >expect
 echo 'A signed tag message' >>expect
@@ -475,12 +635,107 @@ echo '-----BEGIN PGP SIGNATURE-----' >>expect
 test_expect_success 'creating a signed tag with -m message should succeed' '
        git-tag -s -m "A signed tag message" signed-tag &&
        get_tag_msg signed-tag >actual &&
-       git diff expect actual
+       test_cmp expect actual
+'
+
+get_tag_header u-signed-tag $commit commit $time >expect
+echo 'Another message' >>expect
+echo '-----BEGIN PGP SIGNATURE-----' >>expect
+test_expect_success 'sign with a given key id' '
+
+       git tag -u committer@example.com -m "Another message" u-signed-tag &&
+       get_tag_msg u-signed-tag >actual &&
+       test_cmp expect actual
+
+'
+
+test_expect_success 'sign with an unknown id (1)' '
+
+       ! git tag -u author@example.com -m "Another message" o-signed-tag
+
+'
+
+test_expect_success 'sign with an unknown id (2)' '
+
+       ! git tag -u DEADBEEF -m "Another message" o-signed-tag
+
+'
+
+cat >fakeeditor <<'EOF'
+#!/bin/sh
+test -n "$1" && exec >"$1"
+echo A signed tag message
+echo from a fake editor.
+EOF
+chmod +x fakeeditor
+
+get_tag_header implied-sign $commit commit $time >expect
+./fakeeditor >>expect
+echo '-----BEGIN PGP SIGNATURE-----' >>expect
+test_expect_success '-u implies signed tag' '
+       GIT_EDITOR=./fakeeditor git-tag -u CDDE430D implied-sign &&
+       get_tag_msg implied-sign >actual &&
+       test_cmp expect actual
+'
+
+cat >sigmsgfile <<EOF
+Another signed tag
+message in a file.
+EOF
+get_tag_header file-signed-tag $commit commit $time >expect
+cat sigmsgfile >>expect
+echo '-----BEGIN PGP SIGNATURE-----' >>expect
+test_expect_success \
+       'creating a signed tag with -F messagefile should succeed' '
+       git-tag -s -F sigmsgfile file-signed-tag &&
+       get_tag_msg file-signed-tag >actual &&
+       test_cmp expect actual
+'
+
+cat >siginputmsg <<EOF
+A signed tag message from
+the standard input
+EOF
+get_tag_header stdin-signed-tag $commit commit $time >expect
+cat siginputmsg >>expect
+echo '-----BEGIN PGP SIGNATURE-----' >>expect
+test_expect_success 'creating a signed tag with -F - should succeed' '
+       git-tag -s -F - stdin-signed-tag <siginputmsg &&
+       get_tag_msg stdin-signed-tag >actual &&
+       test_cmp expect actual
+'
+
+get_tag_header implied-annotate $commit commit $time >expect
+./fakeeditor >>expect
+echo '-----BEGIN PGP SIGNATURE-----' >>expect
+test_expect_success '-s implies annotated tag' '
+       GIT_EDITOR=./fakeeditor git-tag -s implied-annotate &&
+       get_tag_msg implied-annotate >actual &&
+       test_cmp expect actual
+'
+
+test_expect_success \
+       'trying to create a signed tag with non-existing -F file should fail' '
+       ! test -f nonexistingfile &&
+       ! tag_exists nosigtag &&
+       ! git-tag -s -F nonexistingfile nosigtag &&
+       ! tag_exists nosigtag
 '
 
 test_expect_success 'verifying a signed tag should succeed' \
        'git-tag -v signed-tag'
 
+test_expect_success 'verifying two signed tags in one command should succeed' \
+       'git-tag -v signed-tag file-signed-tag'
+
+test_expect_success \
+       'verifying many signed and non-signed tags should fail' '
+       ! git-tag -v signed-tag annotated-tag &&
+       ! git-tag -v file-annotated-tag file-signed-tag &&
+       ! git-tag -v annotated-tag file-signed-tag file-annotated-tag &&
+       ! git-tag -v signed-tag annotated-tag file-signed-tag
+'
+
 test_expect_success 'verifying a forged tag should fail' '
        forged=$(git cat-file tag signed-tag |
                sed -e "s/signed-tag/forged-tag/" |
@@ -497,7 +752,7 @@ test_expect_success \
        'creating a signed tag with an empty -m message should succeed' '
        git-tag -s -m "" empty-signed-tag &&
        get_tag_msg empty-signed-tag >actual &&
-       git diff expect actual &&
+       test_cmp expect actual &&
        git-tag -v empty-signed-tag
 '
 
@@ -508,7 +763,7 @@ test_expect_success \
        'creating a signed tag with an empty -F messagefile should succeed' '
        git-tag -s -F sigemptyfile emptyfile-signed-tag &&
        get_tag_msg emptyfile-signed-tag >actual &&
-       git diff expect actual &&
+       test_cmp expect actual &&
        git-tag -v emptyfile-signed-tag
 '
 
@@ -531,7 +786,7 @@ test_expect_success \
        'extra blanks in the message for a signed tag should be removed' '
        git-tag -s -F sigblanksfile blanks-signed-tag &&
        get_tag_msg blanks-signed-tag >actual &&
-       git diff expect actual &&
+       test_cmp expect actual &&
        git-tag -v blanks-signed-tag
 '
 
@@ -541,7 +796,7 @@ test_expect_success \
        'creating a signed tag with a blank -m message should succeed' '
        git-tag -s -m "     " blank-signed-tag &&
        get_tag_msg blank-signed-tag >actual &&
-       git diff expect actual &&
+       test_cmp expect actual &&
        git-tag -v blank-signed-tag
 '
 
@@ -554,7 +809,7 @@ test_expect_success \
        'creating a signed tag with blank -F file with spaces should succeed' '
        git-tag -s -F sigblankfile blankfile-signed-tag &&
        get_tag_msg blankfile-signed-tag >actual &&
-       git diff expect actual &&
+       test_cmp expect actual &&
        git-tag -v blankfile-signed-tag
 '
 
@@ -565,7 +820,7 @@ test_expect_success \
        'creating a signed tag with spaces and no newline should succeed' '
        git-tag -s -F sigblanknonlfile blanknonlfile-signed-tag &&
        get_tag_msg blanknonlfile-signed-tag >actual &&
-       git diff expect actual &&
+       test_cmp expect actual &&
        git-tag -v signed-tag
 '
 
@@ -602,7 +857,7 @@ test_expect_success \
        'creating a signed tag with a -F file with #comments should succeed' '
        git-tag -s -F sigcommentsfile comments-signed-tag &&
        get_tag_msg comments-signed-tag >actual &&
-       git diff expect actual &&
+       test_cmp expect actual &&
        git-tag -v comments-signed-tag
 '
 
@@ -612,7 +867,7 @@ test_expect_success \
        'creating a signed tag with #commented -m message should succeed' '
        git-tag -s -m "#comment" comment-signed-tag &&
        get_tag_msg comment-signed-tag >actual &&
-       git diff expect actual &&
+       test_cmp expect actual &&
        git-tag -v comment-signed-tag
 '
 
@@ -625,7 +880,7 @@ test_expect_success \
        'creating a signed tag with #commented -F messagefile should succeed' '
        git-tag -s -F sigcommentfile commentfile-signed-tag &&
        get_tag_msg commentfile-signed-tag >actual &&
-       git diff expect actual &&
+       test_cmp expect actual &&
        git-tag -v commentfile-signed-tag
 '
 
@@ -636,10 +891,106 @@ test_expect_success \
        'creating a signed tag with a #comment and no newline should succeed' '
        git-tag -s -F sigcommentnonlfile commentnonlfile-signed-tag &&
        get_tag_msg commentnonlfile-signed-tag >actual &&
-       git diff expect actual &&
+       test_cmp expect actual &&
        git-tag -v commentnonlfile-signed-tag
 '
 
+# listing messages for signed tags:
+
+test_expect_success \
+       'listing the one-line message of a signed tag should succeed' '
+       git-tag -s -m "A message line signed" stag-one-line &&
+
+       echo "stag-one-line" >expect &&
+       git-tag -l | grep "^stag-one-line" >actual &&
+       test_cmp expect actual &&
+       git-tag -n0 -l | grep "^stag-one-line" >actual &&
+       test_cmp expect actual &&
+       git-tag -n0 -l stag-one-line >actual &&
+       test_cmp expect actual &&
+
+       echo "stag-one-line   A message line signed" >expect &&
+       git-tag -n1 -l | grep "^stag-one-line" >actual &&
+       test_cmp expect actual &&
+       git-tag -n -l | grep "^stag-one-line" >actual &&
+       test_cmp expect actual &&
+       git-tag -n1 -l stag-one-line >actual &&
+       test_cmp expect actual &&
+       git-tag -n2 -l stag-one-line >actual &&
+       test_cmp expect actual &&
+       git-tag -n999 -l stag-one-line >actual &&
+       test_cmp expect actual
+'
+
+test_expect_success \
+       'listing the zero-lines message of a signed tag should succeed' '
+       git-tag -s -m "" stag-zero-lines &&
+
+       echo "stag-zero-lines" >expect &&
+       git-tag -l | grep "^stag-zero-lines" >actual &&
+       test_cmp expect actual &&
+       git-tag -n0 -l | grep "^stag-zero-lines" >actual &&
+       test_cmp expect actual &&
+       git-tag -n0 -l stag-zero-lines >actual &&
+       test_cmp expect actual &&
+
+       echo "stag-zero-lines " >expect &&
+       git-tag -n1 -l | grep "^stag-zero-lines" >actual &&
+       test_cmp expect actual &&
+       git-tag -n -l | grep "^stag-zero-lines" >actual &&
+       test_cmp expect actual &&
+       git-tag -n1 -l stag-zero-lines >actual &&
+       test_cmp expect actual &&
+       git-tag -n2 -l stag-zero-lines >actual &&
+       test_cmp expect actual &&
+       git-tag -n999 -l stag-zero-lines >actual &&
+       test_cmp expect actual
+'
+
+echo 'stag line one' >sigtagmsg
+echo 'stag line two' >>sigtagmsg
+echo 'stag line three' >>sigtagmsg
+test_expect_success \
+       'listing many message lines of a signed tag should succeed' '
+       git-tag -s -F sigtagmsg stag-lines &&
+
+       echo "stag-lines" >expect &&
+       git-tag -l | grep "^stag-lines" >actual &&
+       test_cmp expect actual &&
+       git-tag -n0 -l | grep "^stag-lines" >actual &&
+       test_cmp expect actual &&
+       git-tag -n0 -l stag-lines >actual &&
+       test_cmp expect actual &&
+
+       echo "stag-lines      stag line one" >expect &&
+       git-tag -n1 -l | grep "^stag-lines" >actual &&
+       test_cmp expect actual &&
+       git-tag -n -l | grep "^stag-lines" >actual &&
+       test_cmp expect actual &&
+       git-tag -n1 -l stag-lines >actual &&
+       test_cmp expect actual &&
+
+       echo "    stag line two" >>expect &&
+       git-tag -n2 -l | grep "^ *stag.line" >actual &&
+       test_cmp expect actual &&
+       git-tag -n2 -l stag-lines >actual &&
+       test_cmp expect actual &&
+
+       echo "    stag line three" >>expect &&
+       git-tag -n3 -l | grep "^ *stag.line" >actual &&
+       test_cmp expect actual &&
+       git-tag -n3 -l stag-lines >actual &&
+       test_cmp expect actual &&
+       git-tag -n4 -l | grep "^ *stag.line" >actual &&
+       test_cmp expect actual &&
+       git-tag -n4 -l stag-lines >actual &&
+       test_cmp expect actual &&
+       git-tag -n99 -l | grep "^ *stag.line" >actual &&
+       test_cmp expect actual &&
+       git-tag -n99 -l stag-lines >actual &&
+       test_cmp expect actual
+'
+
 # tags pointing to objects different from commits:
 
 tree=$(git rev-parse HEAD^{tree})
@@ -653,7 +1004,7 @@ test_expect_success \
        'creating a signed tag pointing to a tree should succeed' '
        git-tag -s -m "A message for a tree" tree-signed-tag HEAD^{tree} &&
        get_tag_msg tree-signed-tag >actual &&
-       git diff expect actual
+       test_cmp expect actual
 '
 
 get_tag_header blob-signed-tag $blob blob $time >expect
@@ -663,7 +1014,7 @@ test_expect_success \
        'creating a signed tag pointing to a blob should succeed' '
        git-tag -s -m "A message for a blob" blob-signed-tag HEAD:foo &&
        get_tag_msg blob-signed-tag >actual &&
-       git diff expect actual
+       test_cmp expect actual
 '
 
 get_tag_header tag-signed-tag $tag tag $time >expect
@@ -673,14 +1024,47 @@ test_expect_success \
        'creating a signed tag pointing to another tag should succeed' '
        git-tag -s -m "A message for another tag" tag-signed-tag signed-tag &&
        get_tag_msg tag-signed-tag >actual &&
-       git diff expect actual
+       test_cmp expect actual
 '
 
+# try to sign with bad user.signingkey
+git config user.signingkey BobTheMouse
+test_expect_success \
+       'git-tag -s fails if gpg is misconfigured' \
+       '! git tag -s -m tail tag-gpg-failure'
+git config --unset user.signingkey
+
 # try to verify without gpg:
 
 rm -rf gpghome
-test_expect_failure \
+test_expect_success \
        'verify signed tag fails when public key is not present' \
-       'git-tag -v signed-tag'
+       '! git-tag -v signed-tag'
+
+test_expect_success \
+       'git-tag -a fails if tag annotation is empty' '
+       ! (GIT_EDITOR=cat git tag -a initial-comment)
+'
+
+test_expect_success \
+       'message in editor has initial comment' '
+       GIT_EDITOR=cat git tag -a initial-comment > actual
+       # check the first line --- should be empty
+       first=$(sed -e 1q <actual) &&
+       test -z "$first" &&
+       # remove commented lines from the remainder -- should be empty
+       rest=$(sed -e 1d -e '/^#/d' <actual) &&
+       test -z "$rest"
+'
+
+get_tag_header reuse $commit commit $time >expect
+echo "An annotation to be reused" >> expect
+test_expect_success \
+       'overwriting an annoted tag should use its previous body' '
+       git tag -a -m "An annotation to be reused" reuse &&
+       GIT_EDITOR=true git tag -f -a reuse &&
+       get_tag_msg reuse >actual &&
+       test_cmp expect actual
+'
 
 test_done